#region usings
using System;
using System.ComponentModel.Composition;

using VVVV.PluginInterfaces.V1;
using VVVV.PluginInterfaces.V2;
using VVVV.Utils.VColor;
using VVVV.Utils.VMath;

using VVVV.Core.Logging;

using System.Collections.Generic;
#endregion usings

namespace VVVV.Nodes
{
	#region PluginInfo
	[PluginInfo(Name = "IteratePath", Category = "Value", Help = "Basic template with one value in/out", Tags = "")]
	#endregion PluginInfo
	public class ValueIteratePathNode : IPluginEvaluate
	{
		#region fields & pins
		[Input("Input Position", DefaultValue = 1.0)]
		ISpread<double> FInput;
		[Input("Width", DefaultValue = 1.0)]
		ISpread<double> FWidth;
		[Input("Points in Queue")]
		ISpread<int> FPointsInQueue;
		[Input("New Path")]
		ISpread<bool> FNewPath;

		[Output("Position Queue")]
		ISpread<double> FQueue;
		[Output("LookAt Queue")]
		ISpread<double> FQueue2;
		[Output("Steps Passed")]
		ISpread<int> FPassed;
		int passed;

		[Import()]
		ILogger FLogger;
		#endregion fields & pins

		List<double> points = new List<double>();
		//called when data for any output pin is requested
		public void Evaluate(int SpreadMax)
		{
			FQueue.SliceCount = FPointsInQueue[0];
			FQueue2.SliceCount = FPointsInQueue[0];
			FPassed.SliceCount = 1;
			
			//	stack the points with values
			if (FNewPath[0]) {
				points.Clear();
				points.Add(0.0);
				passed = 0;
			}
			while (points.Count<=FPointsInQueue[0]+1) {
				points.Add(points[points.Count-1]+FWidth[0]/FPointsInQueue[0]);
			}

			if (points[1]<FInput[0]) {
				points.RemoveAt(0);
				points.Add(points[points.Count-1]+FWidth[0]/FPointsInQueue[0]);
				passed++;
			}
			
			for (int i = 0; i < FPointsInQueue[0]; i++) {
				FQueue[i] = points[i];
				FQueue2[i] = points[i+1];
			}
			FPassed[0] = passed;
		}
	}
}
